var MyAjax;

function wppfm_getFeedList( callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-get-list-of-feeds',
			postFeedsListNonce: MyAjax.postFeedsListNonce,

		},
		function( response ) {

			callback( wppfm_validateResponse( response ) );
		}
	);
}

function wppfm_getBackupsList( callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-get-list-of-backups',
			postBackupListNonce: MyAjax.postBackupListNonce,

		},
		function( response ) {

			callback( wppfm_validateResponse( response ) );
		}
	);
}

function wppfm_getSettingsOptions( callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-get-settings-options',
			postSetupOptionsNonce: MyAjax.postSetupOptionsNonce,

		},
		function( response ) {

			callback( wppfm_validateResponse( response ) );
		}
	);
}

/**
 * Reads and returns all possible output fields from the selected merchant
 *
 * @param {int} feedId
 * @param {int} channelId
 * @param callback
 * @returns list with output fields
 */
function wppfm_getOutputFields( feedId, channelId, callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-get-output-fields',
			feedId: feedId,
			channelId: channelId,
			outputFieldsNonce: MyAjax.outputFieldsNonce,

		},
		function( response ) {

			callback( wppfm_validateResponse( response ) );
		}
	);
}

/**
 * Reads and returns all possible source fields from the selected source
 *
 * @param {int} sourceId
 * @param callback
 * @returns list with input fields
 */
function wppfm_getSourceFields( sourceId, callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-get-input-fields',
			sourceId: sourceId,
			inputFieldsNonce: MyAjax.inputFieldsNonce,

		},
		function( response ) {

			callback( wppfm_validateResponse( response ) );
		}
	);
}

function wppfm_getMainFeedFilters( feedId, callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-get-main-feed-filters',
			feedId: feedId,
			inputFeedFiltersNonce: MyAjax.inputFeedFiltersNonce,

		},
		function( response ) {

			callback( wppfm_validateResponse( response ) );
		}
	);
}

function wppfm_getNextCategories( channelId, requestedLevel, parentCategory, language, callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-get-next-categories',
			channelId: channelId,
			requestedLevel: requestedLevel,
			parentCategory: parentCategory,
			fileLanguage: language,
			nextCategoryNonce: MyAjax.nextCategoryNonce,

		},
		function( response ) {

			response = response.trim();

			if ( response.substr( response.length - 1 ) === '0' ) {
				response = response.substring( 0, response.length - 1 );
			}

			callback( wppfm_validateResponse( response ) );
		}
	);
}

function wppfm_getCategoryListsFromString( channelId, mainCategoriesString, language, callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-get-category-lists',
			channelId: channelId,
			mainCategories: mainCategoriesString,
			fileLanguage: language,
			categoryListsNonce: MyAjax.categoryListsNonce,

		},
		function( response ) {

			callback( wppfm_validateResponse( response ) );
		}
	);
}

function wppfm_updateFeedToDb( feed, metaData, callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-update-feed-data',
			feedId: feed[ 'feedId' ],
			channelId: feed[ 'channel' ],
			includeVariations: feed[ 'includeVariations' ],
			isAggregator: feed[ 'isAggregator' ],
			countryId: feed[ 'country' ],
			language: feed[ 'language' ],
			sourceId: feed[ 'dataSource' ],
			title: feed[ 'title' ],
			feedTitle: feed[ 'feedTitle' ],
			feedDescription: feed[ 'feedDescription' ],
			defaultCategory: feed[ 'mainCategory' ],
			url: feed[ 'url' ],
			status: feed[ 'status' ],
			schedule: feed[ 'updateSchedule' ],
			feedFilter: feed[ 'feedFilter' ] ? feed[ 'feedFilter' ][ 0 ][ 'meta_value' ] : '',
			metaData: JSON.stringify( metaData ),
			updateFeedDataNonce: MyAjax.updateFeedDataNonce,
		},
		function( response ) {

			callback( wppfm_validateResponse( response ) );
		}
	);
}

function wppfm_updateFeedFile( feed_id, callback ) {
	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-update-feed-file',
			dataType: 'text',
			feedId: feed_id,
			updateFeedFileNonce: MyAjax.updateFeedFileNonce,

		},
		function( response ) {

			callback( wppfm_validateResponse( response ) );
		}
	);
}

function wppfm_getCurrentFeedStatus( feedId, callback ) {
	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-get-feed-status',
			sourceId: feedId,
			feedStatusNonce: MyAjax.feedStatusNonce,

		},
		function( response ) {
			callback( wppfm_validateResponse( response ) );
		}
	);
}

function wppfm_getFeedData( feedId, callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-get-feed-data',
			sourceId: feedId,
			feedDataNonce: MyAjax.feedDataNonce,

		},
		function( response ) {

			callback( wppfm_validateResponse( response ) );
		}
	);
}

function wppfm_switchFeedStatus( feedId, callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-switch-feed-status',
			feedId: feedId,
			switchFeedStatusNonce: MyAjax.switchFeedStatusNonce,

		},
		function( response ) {

			callback( wppfm_validateResponse( response ) );
		}
	);
}

function wppfm_duplicateExistingFeed( feedId, callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-duplicate-existing-feed',
			feedId: feedId,
			duplicateFeedNonce: MyAjax.duplicateFeedNonce,

		},
		function( response ) {

			if ( response.trim() ) {
				wppfm_resetFeedList();
			}

			callback( wppfm_validateResponse( response ) );
		}
	);
}

function wppfm_logMessageOnServer( message, fileName, callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-log-message',
			messageList: message,
			fileName: fileName,
			logMessageNonce: MyAjax.logMessageNonce,

		},
		function( result ) {

			callback( result.trim() );
		}
	);
}

function wppfm_auto_feed_fix_mode( selection, callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-auto-feed-fix-mode-selection',
			fix_selection: selection,
			updateAutoFeedFixNonce: MyAjax.setAutoFeedFixNonce,

		},
		function( response ) {

			callback( response.trim() );
		}
	);
}

function wppfm_background_processing_mode( selection, callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-background-processing-mode-selection',
			mode_selection: selection,
			backgroundModeNonce: MyAjax.setBackgroundModeNonce,

		},
		function( response ) {

			callback( response.trim() );
		}
	);
}

function wppfm_change_third_party_attribute_keywords( keywords, callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-third-party-attribute-keywords',
			keywords: keywords,
			thirdPartyKeywordsNonce: MyAjax.setThirdPartyKeywordsNonce,

		},
		function( response ) {

			callback( response.trim() );
		}
	);
}

function wppfm_change_notice_mailaddress( mailAddress, callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-set-notice-mailaddress',
			mailaddress: mailAddress,
			noticeMailaddressNonce: MyAjax.setNoticeMailaddressNonce,

		},
		function( response ) {

			callback( response.trim() );
		}
	);
}

function wppfm_change_background_processing_time_limit( limit, callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-background-processing-time-limit',
			limit: limit,
			batchProcessingLimitNonce: MyAjax.setBatchProcessingLimitNonce,

		},
		function( response ) {

			callback( response.trim() );
		}
	);
}

function wppfm_clear_feed_process_data( callback ) {
	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-clear-feed-process-data',
			clearFeedNonce: MyAjax.setClearFeedProcessNonce,

		},
		function( response ) {

			callback( response );
		}
	);
}

function wppfm_reinitiate_plugin( callback ) {
	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-reinitiate-plugin',
			reInitiateNonce: MyAjax.setReInitiateNonce,

		},
		function( response ) {

			callback( response );
		}
	);
}

/**
 * Takes the response of an ajax call and checks if it's ok. When not, it will display the error and return
 * an empty list.
 *
 * @param {String} response
 * @returns {String}
 */
function wppfm_validateResponse( response ) {

	response = response.trim(); // remove php ajax response white spaces

	// when the response contains no error message
	if ( response.indexOf( '<div id=\'error\'>' ) < 0 && response.indexOf( '<b>Fatal error</b>' ) < 0 && response.indexOf( '<b>Notice</b>' ) < 0 && response.indexOf( '<b>Warning</b>' ) < 0 && response.indexOf( '<b>Catchable fatal error</b>' ) < 0 && response.indexOf( '<div id="error">' ) < 0 ) {

		if ( response.indexOf( '[]' ) < 0 ) {

			if ( response !== '' ) {

				return (
					response
				);
			} else {

				return (
					'1'
				);
			}
		} else { // if it has an error message

			// return an empty list
			return (
				'0'
			);
		}
	} else {

		wppfm_show_error_message( response.replace( '[]', '' ) );
		wppfm_hide_feed_spinner();

		wppfm_logMessageOnServer(
			response,
			'error',
			function( result ) {

				// return an empty list
				return (
					'0'
				);
			}
		);
	}
}

/**
 * Deletes a specific feed file
 *
 * This function first removes the file from the server and than from the feed database.
 * After that it will refresh the Feed List.
 *
 * @param {int} id
 * @param {string} feedTitle
 * @returns nothing
 */
function wppfm_deleteFeed( id, feedTitle ) {
	var feedSpinnerElement     = jQuery( '#feed-spinner' );
	var feedListMessageElement = jQuery( '#feed-list-message' );

	// clear old messages
	feedListMessageElement.empty();

	// remove the file
	wppfm_removeFeedFile(
		function() {
			feedSpinnerElement.show();

			// delete the file entry in the database
			wppfm_deleteFeedFromDb(
				id,
				function( response ) {
					feedSpinnerElement.show();

					response = response.trim();

					if ( response === '1' ) {
						// reset the feed list
						wppfm_resetFeedList();
						feedSpinnerElement.hide();
					} else {
						// report the result to the user
						feedListMessageElement.append( response );
						feedSpinnerElement.hide();
					}
				},
				id
			);
		},
		feedTitle
	);
}

function wppfm_removeFeedFile( callback, feedTitle ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-delete-feed-file',
			fileTitle: feedTitle,
			deleteFeedNonce: MyAjax.deleteFeedNonce,

		},
		function( response ) {

			callback( wppfm_validateResponse( response ) );
		}
	);
}

function wppfm_deleteFeedFromDb( feedId, callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-delete-feed',
			feedId: feedId,
			deleteFeedNonce: MyAjax.deleteFeedNonce,

		},
		function( response ) {

			callback( wppfm_validateResponse( response ) );
		}
	);
}

function wppfm_checkNextFeedInQueue( callback ) {
	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-get-next-feed-in-queue',
			nextFeedInQueueNonce: MyAjax.nextFeedInQueueNonce,

		},
		function( response ) {

			callback( wppfm_validateResponse( response ) );
		}
	);
}

function wppfm_initiateBackup( fileName, callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-backup-current-data',
			fileName: fileName,
			backupNonce: MyAjax.backupNonce,

		},
		function( response ) {

			callback( wppfm_validateResponse( response ) );
		}
	);
}

function wppfm_deleteBackup( fileName, callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-delete-backup-file',
			fileName: fileName,
			deleteBackupNonce: MyAjax.deleteBackupNonce,

		},
		function( response ) {

			callback( wppfm_validateResponse( response ) );
		}
	);
}

function wppfm_restoreBackup( fileName, callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-restore-backup-file',
			fileName: fileName,
			restoreBackupNonce: MyAjax.restoreBackupNonce,

		},
		function( response ) {

			callback( wppfm_validateResponse( response ) );
		}
	);
}

function wppfm_duplicateBackup( fileName, callback ) {

	jQuery.post(
		MyAjax.ajaxurl,
		{
			action: 'myajax-duplicate-backup-file',
			fileName: fileName,
			duplicateBackupNonce: MyAjax.duplicateBackupNonce,

		},
		function( response ) {

			callback( wppfm_validateResponse( response ) );
		}
	);
}
